<?php

/**

 * Cobalt by MintJoomla

 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)

 * Author Website: http://www.mintjoomla.com/

 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.

 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html

 */

defined('_JEXEC') or die;

require_once JPATH_ROOT. DIRECTORY_SEPARATOR .'components/com_cobalt/library/php/fields/cobaltselectable.php';





class JFormFieldCRange extends CFormField

{

	protected $type = 'Range';



	public function getInput()

	{

		$params = $this->params;

		$doc = JFactory::getDocument();

		$this->user = JFactory::getUser();



		$values1 = array();

		if ($params->get('params.sql_source'))

		{

			$values1 = $this->_getSqlValues();

		}

		else

		{

			$values1 = explode("\n", $params->get('params.values1'));

			ArrayHelper::clean_r($values1);

			if (is_array($this->value1))

			{

				$this->value1 = trim(@$this->value1[0]);

			}

			if (!in_array($this->value1, $values1))

			{

				$values1[] = $this->value1;

			}

			ArrayHelper::clean_r($values1);



			if ($params->get('params.sort') == 2)

				asort($values1);

			if ($params->get('params.sort') == 3)

				rsort($values1);

		}



		$this->values1 = $values1;



		$values2 = array();

		if ($params->get('params.sql_source'))

		{

			$values2 = $this->_getSqlValues();

		}

		else

		{

			$values2 = explode("\n", $params->get('params.values2'));

			ArrayHelper::clean_r($values2);

			if (is_array($this->value2))

			{

				$this->value2 = trim(@$this->value2[0]);

			}

			if (!in_array($this->value2, $values2))

			{

				$values2[] = $this->value2;

			}

			ArrayHelper::clean_r($values2);



			if ($params->get('params.sort') == 2)

				asort($values2);

			if ($params->get('params.sort') == 3)

				rsort($values2);

		}



		$this->values2 = $values2;



		if($this->isnew && $this->params->get('params.default_val'))

		{

			$this->value1 = $this->params->get('params.default_val');

			$this->value2 = $this->params->get('params.default_val');

		}



		return $this->_display_input();



	}



	public function onJSValidate()

	{

		$js = "\n\t\tvar chb{$this->id} = jQuery('[name^=\"jform\\\\[fields\\\\]\\\\[$this->id\\\\]\"]').val();";

		if($this->required)

		{

			$js .= "\n\t\tif(!chb{$this->id}){hfid.push({$this->id}); isValid = false; errorText.push('".addslashes(JText::sprintf("CFIELDREQUIRED", $this->label))."');}";

		}

		return $js;

	}



	public function onFilterWornLabel($section)

	{

		$value = $this->value;



		settype($value, 'array');

		return  JText::sprintf($this->params->get('params.filter_worn', 'P_BETWEEN'),

			'<b>'.$this->params->get('params.prepend').number_format($value['min'], $this->params->get('params.decimals_num', 0), $this->params->get('params.dseparator', '.'), $this->params->get('params.separator', ',')).$this->params->get('params.append').'</b>',

			'<b>'.$this->params->get('params.prepend').number_format($value['max'], $this->params->get('params.decimals_num', 0), $this->params->get('params.dseparator', '.'), $this->params->get('params.separator', ',')).$this->params->get('params.append').'</b>');

	}



	public function onFilterWhere($section, &$query)

	{

		$db  = JFactory::getDbo();

		$sql = $db->getQuery(TRUE);



		$sql->select('v.record_id');

		$sql->from('#__js_res_record_values AS v');

		$sql->where('v.section_id = ' . $section->id);

		$sql->where('v.field_key = ' . $db->quote($this->key));



		$value = $this->value;

		settype($value, 'array');

		ArrayHelper::trim_r($value);



		if(empty($value['min']) || empty($value['max']))

		{

			return NULL;

		}



		if($value['min'] == $value['max'])

		{

			return NULL;

		}



		$data = $this->_get_min_max($section);



		if($value['min'] == $data->min && $value['max'] == $data->max)

		{

			return null;

		}

         /*

		$ids = $this->getIds("SELECT record_id FROM #__js_res_record_values as f

			WHERE (f.field_value + 0 >= {$value['min']}

			  AND f.field_value + 0 <= {$value['max']})

			  AND section_id = {$section->id}

			  AND field_key = '{$this->key}'");

		$query->where("r.id IN(".implode(',', $ids).")");

		    */

		$sql->where($value['min'] . " <= (SELECT field_value FROM #__js_res_record_values

							WHERE record_id = v.record_id AND section_id = {$section->id}

							AND field_key = '{$this->key}' AND value_index = 1)

							AND ". $value['min'] . " <= (SELECT field_value FROM #__js_res_record_values

				WHERE record_id = v.record_id AND section_id = {$section->id}

				AND field_key = '{$this->key}' AND value_index = 1)");



		$sql->where($value['max'] . " >= (SELECT field_value FROM #__js_res_record_values

				WHERE record_id = v.record_id AND section_id = {$section->id}

				AND field_key = '{$this->key}' AND value_index = 0)

				AND ". $value['max'] . " >= (SELECT field_value FROM #__js_res_record_values

				WHERE record_id = v.record_id AND section_id = {$section->id}

				AND field_key = '{$this->key}' AND value_index = 0)");



        $ids = $this->getIds((string)$sql);

		$query->where("r.id IN(" . implode(',', $ids) . ")");



		return TRUE;

	}



	private function _get_min_max($section) {



		static $out = array();



		if(!array_key_exists($this->id, $out))

		{

			$db = JFactory::getDbo();

			$query = $db->getQuery(TRUE);

			$query->select('MAX(field_value + 0) as max, MIN(field_value + 0) as min');

			$query->from('#__js_res_record_values as f');

			$query->where("`section_id` = {$section->id}");

			$query->where("`field_key` = '{$this->key}'");

			$db->setQuery($query);



			$out[$this->id] = $db->loadObject();

		}



		return $out[$this->id];

	}





	public function onRenderFilter($section, $module = false)

	{



		$this->value = new JRegistry($this->value);



		$this->data = $this->_get_min_max($section);



		return $this->_display_filter($section, $module);

	}





	public function onRenderFull($record, $type, $section)

	{

		return $this->_render('full', $record, $type, $section);

	}



	public function onRenderList($record, $type, $section)

	{

		return $this->_render('list', $record, $type, $section);

	}



	private function _render($client, $record, $type, $section )

	{

		if(($this->value[0] === null || $this->value[0] === '' )&&

			($this->value[1] === null || $this->value[1] === '' )) return NULL;



		return $this->_display_output($client, $record, $type, $section);

	}

	public function isFilterActive()

	{

		if(!$this->value) return 0;



		$value = $this->value;

		if(is_array($value))

		{

			$value = new JRegistry($value);

		}



		$min = $value->get('min');

		$max = $value->get('max');

		if(!empty($min) && !empty($max))

		{

			return 1;

		}

		return 0;

	}



	public function onPrepareSave($value, $record, $type, $section)

	{

		//$filter = JFilterInput::getInstance();

		//return $filter->clean($value);

		return $value;

	}

	public function onStoreValues($validData, $record)

	{

		//die("storeValues");		ArrayHelper::clean_r($this->value);

		if(count($this->value) == 0)

		{

			return;

		}



		//$value_first = $this->value[0];

		//$value_second = $this->value[1];



		return $this->value;

	}



	public function onImport($value, $params, $record = null)

	{    /*

		settype($value, 'float');

		$value = round($value, $this->params->get('params.decimals_num', 0));

		return $value;

		   */

		  // die($value);

		$values = explode($params->get('field.' . $this->id . '.separator', ','), $value);

		ArrayHelper::clean_r($values);

		return $values;

	}



	public function onImportForm($heads, $defaults)

	{

		return $this->_import_fieldlist($heads, $defaults->get('field.' . $this->id));

	}



	public function onPrepareFullTextSearch($value, $record, $type, $section)

	{

		return $value;

	}

}

